import { AfterContentInit, ChangeDetectorRef, EventEmitter, QueryList } from '@angular/core';
import { SbbProcessflowStepBase, SbbProcessflowStepDescriptor } from './processflow-step-base';
export declare abstract class SbbProcessflowBase<TProcessflowStepComponent extends SbbProcessflowStepBase> implements AfterContentInit {
    protected _changeDetectorRef: ChangeDetectorRef;
    /** Event emitted to the change of step in the process flow. */
    stepChange: EventEmitter<SbbProcessflowStepDescriptor>;
    /** @docs-private */
    abstract steps: QueryList<TProcessflowStepComponent>;
    constructor(_changeDetectorRef: ChangeDetectorRef);
    ngAfterContentInit(): void;
    nextStep(): void;
    prevStep(): void;
    protected _findActiveStepIndex(steps: TProcessflowStepComponent[]): number;
    /**
     * Method to change on a step with a click.
     * @param $event Event generated at the click on a step.
     * @param stepIndex Index of a step.
     */
    stepClick($event: any, stepIndex: number): void;
    /**
     * Method to change a step in a process flow.
     * @param index Index of the step to change.
     */
    changeStep(index: number): void;
    /** Method to disable a step in a process flow.
     * @param index Index of the step to disable.
     */
    disableStep(index: number): void;
    reset(): void;
    getActiveStep(): TProcessflowStepComponent | null;
}
