(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/keycodes'), require('@angular/cdk/overlay'), require('@angular/cdk/platform'), require('@angular/core'), require('@sbb-esta/angular-core/icon-directive'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@sbb-esta/angular-core/base/tooltip', ['exports', '@angular/cdk/keycodes', '@angular/cdk/overlay', '@angular/cdk/platform', '@angular/core', '@sbb-esta/angular-core/icon-directive', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.sbbEsta = global.sbbEsta || {}, global.sbbEsta.angularCore = global.sbbEsta.angularCore || {}, global.sbbEsta.angularCore.base = global.sbbEsta.angularCore.base || {}, global.sbbEsta.angularCore.base.tooltip = {}), global.ng.cdk.keycodes, global.ng.cdk.overlay, global.ng.cdk.platform, global.ng.core, global.ng.angularCore.iconDirective, global.rxjs, global.rxjs.operators));
}(this, (function (exports, keycodes, overlay, platform, i0, iconDirective, rxjs, operators) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    var SbbTooltipRegistryService = /** @class */ (function () {
        function SbbTooltipRegistryService() {
            this._tooltipActivationSubject = new rxjs.Subject();
            this.tooltipActivation = this._tooltipActivationSubject.asObservable();
        }
        SbbTooltipRegistryService.prototype.activate = function () {
            this._tooltipActivationSubject.next();
        };
        return SbbTooltipRegistryService;
    }());
    SbbTooltipRegistryService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function SbbTooltipRegistryService_Factory() { return new SbbTooltipRegistryService(); }, token: SbbTooltipRegistryService, providedIn: "root" });
    SbbTooltipRegistryService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];

    /** Injection token that determines the scroll handling while the calendar is open. */
    var SBB_TOOLTIP_SCROLL_STRATEGY = new i0.InjectionToken('sbb-tooltip-scroll-strategy');
    /** @docs-private */
    function SBB_TOOLTIP_SCROLL_STRATEGY_FACTORY(overlay) {
        return function () { return overlay.scrollStrategies.reposition(); };
    }
    /** @docs-private */
    var SBB_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER = {
        provide: SBB_TOOLTIP_SCROLL_STRATEGY,
        deps: [overlay.Overlay],
        useFactory: SBB_TOOLTIP_SCROLL_STRATEGY_FACTORY,
    };
    var SbbTooltipChangeEvent = /** @class */ (function () {
        function SbbTooltipChangeEvent(
        /** Instance of tooltip component. */
        instance, 
        /** States if the tooltip has been opened by a click. */
        isUserInput) {
            if (isUserInput === void 0) { isUserInput = false; }
            this.instance = instance;
            this.isUserInput = isUserInput;
        }
        return SbbTooltipChangeEvent;
    }());
    var tooltipCounter = 1;
    var SbbTooltipBase = /** @class */ (function () {
        function SbbTooltipBase(_overlay, _tooltipRegistry, _document, _zone, _changeDetectorRef, _elementRef, scrollStrategy) {
            this._overlay = _overlay;
            this._tooltipRegistry = _tooltipRegistry;
            this._document = _document;
            this._zone = _zone;
            this._changeDetectorRef = _changeDetectorRef;
            this._elementRef = _elementRef;
            /** Identifier of tooltip. */
            this.id = "sbb-tooltip-id-" + tooltipCounter++;
            /** Identifier of tooltip content. */
            this.contentId = "sbb-tooltip-content-id-" + tooltipCounter++;
            /** Sets whether the overlay can be pushed on-screen if it does not fit otherwise. */
            this.overlayWithPush = false;
            /**
             * Sets whether the overlay's position should be locked in after it is
             * positioned initially.
             * When an overlay is locked in, it won't attempt to reposition itself
             * when the position is re-applied (e.g. when the user scrolls away).
             */
            this.overlayWithLockedPosition = true;
            /** Sets a minimum distance the overlay may be positioned to the edge of the viewport. */
            this.overlayViewportMargin = 8;
            /** Open event to a click on tooltip element. */
            this.opened = new i0.EventEmitter();
            /** Close event to a click on tooltip element. */
            this.closed = new i0.EventEmitter();
            this._closeKeyEventStream = new rxjs.Subject();
            this._panelClass = ['sbb-tooltip-content'];
            this._scrollStrategy = scrollStrategy;
        }
        Object.defineProperty(SbbTooltipBase.prototype, "icon", {
            get: function () {
                return this._contentIcon || this._icon || this.defaultIcon;
            },
            /**
             * The icon to be used as click target.
             * By default uses question-mark, but the user can use his own icon using the IconDirective.
             */
            set: function (tooltipIcon) {
                this._icon = tooltipIcon;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SbbTooltipBase.prototype, "overlayAttached", {
            /** Checks if a tooltip panel exists */
            get: function () {
                return this.tooltipRef && this.tooltipRef.hasAttached();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SbbTooltipBase.prototype, "panelClosingActions", {
            /**
             * A stream of actions that should close the autocomplete panel, including
             * on blur events.
             */
            get: function () {
                var _this = this;
                return rxjs.merge(this._closeKeyEventStream, this._getOutsideClickStream(), this._tooltipRegistry.tooltipActivation, this.tooltipRef
                    ? this.tooltipRef.detachments().pipe(operators.filter(function () { return _this.overlayAttached; }))
                    : rxjs.of()).pipe(
                // Normalize the output so we return a consistent type.
                operators.map(function (event) { return (event instanceof SbbTooltipChangeEvent ? event : null); }));
            },
            enumerable: false,
            configurable: true
        });
        SbbTooltipBase.prototype.ngOnDestroy = function () {
            if (this.tooltipRef) {
                this.tooltipRef.detach();
                this.tooltipRef.dispose();
                this._closingActionsSubscription.unsubscribe();
            }
        };
        SbbTooltipBase.prototype.onClick = function (event) {
            event.stopPropagation();
            // Used to prevent IE11 from forwarding to the input,
            // if sbb-tooltip is placed inside sbb-label.
            event.preventDefault();
            if (this.overlayAttached) {
                this.close(true);
            }
            else {
                this.open(true);
            }
        };
        /**
         * Opens the tooltip
         * @param isUserInput states if the tooltip has been opened by a click
         */
        SbbTooltipBase.prototype.open = function (isUserInput) {
            if (isUserInput === void 0) { isUserInput = false; }
            if (!this.overlayAttached) {
                this._tooltipRegistry.activate();
                this._createPopup();
                this.tooltipRef.attach(this.tooltipContentPortal);
                this._closingActionsSubscription = this._subscribeToClosingActions();
                this.opened.emit(new SbbTooltipChangeEvent(this, isUserInput));
            }
        };
        /**
         * Closes the tooltip
         * @param isUserInput states if the tooltip has been opened by a click
         */
        SbbTooltipBase.prototype.close = function (isUserInput) {
            if (isUserInput === void 0) { isUserInput = false; }
            if (this.overlayAttached) {
                this.tooltipRef.detach();
                this.tooltipRef.dispose();
                this._closingActionsSubscription.unsubscribe();
                this.closed.emit(new SbbTooltipChangeEvent(this, isUserInput));
                this._changeDetectorRef.detectChanges();
            }
        };
        /** Create the popup PositionStrategy. */
        SbbTooltipBase.prototype._createTooltipPositionStrategy = function () {
            return this._overlay
                .position()
                .flexibleConnectedTo(this.tooltipTrigger)
                .withTransformOriginOn('.sbb-tooltip-content')
                .withFlexibleDimensions(false)
                .withViewportMargin(8)
                .withPush(false)
                .withPositions([
                {
                    originX: 'center',
                    originY: 'bottom',
                    overlayX: 'center',
                    overlayY: 'top',
                    panelClass: 'sbb-tooltip-content-below',
                },
                {
                    originX: 'end',
                    originY: 'bottom',
                    overlayX: 'end',
                    overlayY: 'top',
                    offsetX: 5,
                    panelClass: ['sbb-tooltip-content-below', 'sbb-tooltip-content-left'],
                },
                {
                    originX: 'start',
                    originY: 'bottom',
                    overlayX: 'start',
                    overlayY: 'top',
                    offsetX: -5,
                    panelClass: ['sbb-tooltip-content-below', 'sbb-tooltip-content-right'],
                },
                {
                    originX: 'center',
                    originY: 'top',
                    overlayX: 'center',
                    overlayY: 'bottom',
                    panelClass: 'sbb-tooltip-content-above',
                },
                {
                    originX: 'end',
                    originY: 'top',
                    overlayX: 'end',
                    overlayY: 'bottom',
                    offsetX: 5,
                    panelClass: ['sbb-tooltip-content-above', 'sbb-tooltip-content-left'],
                },
                {
                    originX: 'start',
                    originY: 'top',
                    overlayX: 'start',
                    overlayY: 'bottom',
                    offsetX: -5,
                    panelClass: ['sbb-tooltip-content-above', 'sbb-tooltip-content-right'],
                },
            ]);
        };
        /** Stream of clicks outside of the tooltip panel. */
        SbbTooltipBase.prototype._getOutsideClickStream = function () {
            var _this = this;
            if (!this._document) {
                return rxjs.of(null);
            }
            return rxjs.merge(rxjs.fromEvent(this._document, 'mousedown'), rxjs.fromEvent(this._document, 'touchend')).pipe(operators.filter(function (event) {
                // If we're in the Shadow DOM, the event target will be the shadow root, so we have to
                // fall back to check the first element in the path of the click event.
                var clickTarget = (_this._isInsideShadowRoot && event.composedPath ? event.composedPath()[0] : event.target);
                return (_this.overlayAttached &&
                    clickTarget !== _this.tooltipTrigger.nativeElement &&
                    !_this.tooltipTrigger.nativeElement.contains(clickTarget) &&
                    !!_this.tooltipRef &&
                    !_this.tooltipRef.overlayElement.contains(clickTarget));
            }));
        };
        /**
         * This method listens to a stream of panel closing actions and resets the
         * stream every time the option list changes.
         */
        SbbTooltipBase.prototype._subscribeToClosingActions = function () {
            var _this = this;
            var firstStable = this._zone.onStable.asObservable().pipe(operators.take(1));
            // When the zone is stable initially, and when the option list changes...
            return (rxjs.merge(firstStable)
                .pipe(
            // create a new stream of panelClosingActions, replacing any previous streams
            // that were created, and flatten it so our stream only emits closing events...
            operators.switchMap(function () {
                return _this.panelClosingActions;
            }), 
            // when the first closing event occurs...
            operators.take(1))
                // set the value, close the panel, and complete.
                .subscribe(function () {
                _this.close();
            }));
        };
        SbbTooltipBase.prototype._createPopup = function () {
            var _this = this;
            var overlayConfig = new overlay.OverlayConfig({
                positionStrategy: this._createTooltipPositionStrategy(),
                hasBackdrop: false,
                scrollStrategy: this._scrollStrategy(),
                panelClass: this._panelClass,
            });
            // We want to resolve this once, as late as possible so that we can be
            // sure that the element has been moved into its final place in the DOM.
            if (this._isInsideShadowRoot == null) {
                this._isInsideShadowRoot = !!platform._getShadowRoot(this._elementRef.nativeElement);
            }
            this.tooltipRef = this._overlay.create(overlayConfig);
            this.tooltipRef.overlayElement.setAttribute('role', 'tooltip');
            // Use the `keydownEvents` in order to take advantage of
            // the overlay event targeting provided by the CDK overlay.
            this.tooltipRef.keydownEvents().subscribe(function (event) {
                // Close when pressing ESCAPE, based on the a11y guidelines.
                // See: https://www.w3.org/TR/wai-aria-practices-1.1/#textbox-keyboard-interaction
                if (event.keyCode === keycodes.ESCAPE) {
                    _this._closeKeyEventStream.next();
                }
            });
        };
        return SbbTooltipBase;
    }());
    SbbTooltipBase.decorators = [
        { type: i0.Directive }
    ];
    SbbTooltipBase.ctorParameters = function () { return [
        { type: overlay.Overlay },
        { type: SbbTooltipRegistryService },
        { type: undefined },
        { type: i0.NgZone },
        { type: i0.ChangeDetectorRef },
        { type: i0.ElementRef },
        { type: undefined }
    ]; };
    SbbTooltipBase.propDecorators = {
        icon: [{ type: i0.Input }],
        _contentIcon: [{ type: i0.ContentChild, args: [iconDirective.SbbIconDirective, { read: i0.TemplateRef },] }],
        tooltipContentPortal: [{ type: i0.ViewChild, args: ['tooltipTemplate', { static: true },] }],
        tooltipTrigger: [{ type: i0.ViewChild, args: ['triggerButton', { static: true },] }],
        defaultIcon: [{ type: i0.ViewChild, args: ['defaultIcon', { read: i0.TemplateRef, static: true },] }],
        overlayWithPush: [{ type: i0.Input }],
        overlayWithLockedPosition: [{ type: i0.Input }],
        overlayViewportMargin: [{ type: i0.Input }],
        opened: [{ type: i0.Output }],
        closed: [{ type: i0.Output }]
    };

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SBB_TOOLTIP_SCROLL_STRATEGY = SBB_TOOLTIP_SCROLL_STRATEGY;
    exports.SBB_TOOLTIP_SCROLL_STRATEGY_FACTORY = SBB_TOOLTIP_SCROLL_STRATEGY_FACTORY;
    exports.SBB_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER = SBB_TOOLTIP_SCROLL_STRATEGY_FACTORY_PROVIDER;
    exports.SbbTooltipBase = SbbTooltipBase;
    exports.SbbTooltipChangeEvent = SbbTooltipChangeEvent;
    exports.SbbTooltipRegistryService = SbbTooltipRegistryService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-core-base-tooltip.umd.js.map
