(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@sbb-esta/angular-core/icon'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@sbb-esta/angular-core/icon/testing', ['exports', '@angular/core', '@sbb-esta/angular-core/icon', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.sbbEsta = global.sbbEsta || {}, global.sbbEsta.angularCore = global.sbbEsta.angularCore || {}, global.sbbEsta.angularCore.icon = global.sbbEsta.angularCore.icon || {}, global.sbbEsta.angularCore.icon.testing = {}), global.ng.core, global.ng.angularCore.icon, global.rxjs));
}(this, (function (exports, core, icon, rxjs) { 'use strict';

    // tslint:enable:no-any
    /**
     * A null icon registry that must be imported to allow disabling of custom
     * icons.
     */
    var FakeSbbIconRegistry = /** @class */ (function () {
        function FakeSbbIconRegistry() {
        }
        FakeSbbIconRegistry.prototype.addSvgIcon = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.addSvgIconLiteral = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.addSvgIconInNamespace = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.addSvgIconLiteralInNamespace = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.addSvgIconSet = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.addSvgIconSetLiteral = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.addSvgIconSetInNamespace = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.addSvgIconSetLiteralInNamespace = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.registerFontClassAlias = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.classNameForFontAlias = function (alias) {
            return alias;
        };
        FakeSbbIconRegistry.prototype.getDefaultFontSetClass = function () {
            return 'sbb-icons';
        };
        FakeSbbIconRegistry.prototype.getSvgIconFromUrl = function () {
            return rxjs.of(this._generateEmptySvg());
        };
        FakeSbbIconRegistry.prototype.getNamedSvgIcon = function () {
            return rxjs.of(this._generateEmptySvg());
        };
        FakeSbbIconRegistry.prototype.setDefaultFontSetClass = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.hasNamespaceSvgIcon = function () {
            return true;
        };
        FakeSbbIconRegistry.prototype.addSvgIconResolver = function () {
            return this;
        };
        FakeSbbIconRegistry.prototype.ngOnDestroy = function () { };
        FakeSbbIconRegistry.prototype._generateEmptySvg = function () {
            var emptySvg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
            emptySvg.classList.add('fake-testing-svg');
            // Emulate real icon characteristics from `SbbIconRegistry` so size remains consistent in tests.
            emptySvg.setAttribute('fit', '');
            emptySvg.setAttribute('preserveAspectRatio', 'xMidYMid meet');
            emptySvg.setAttribute('focusable', 'false');
            return emptySvg;
        };
        return FakeSbbIconRegistry;
    }());
    FakeSbbIconRegistry.decorators = [
        { type: core.Injectable }
    ];
    /** Import this module in tests to install the null icon registry. */
    var SbbIconTestingModule = /** @class */ (function () {
        function SbbIconTestingModule() {
        }
        return SbbIconTestingModule;
    }());
    SbbIconTestingModule.decorators = [
        { type: core.NgModule, args: [{
                    providers: [{ provide: icon.SbbIconRegistry, useClass: FakeSbbIconRegistry }],
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.FakeSbbIconRegistry = FakeSbbIconRegistry;
    exports.SbbIconTestingModule = SbbIconTestingModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-core-icon-testing.umd.js.map
