import * as i0 from '@angular/core';
import { Injectable } from '@angular/core';

/** Provider that defines how form controls behave with regards to displaying error messages. */
class SbbErrorStateMatcher {
    isErrorState(control, form) {
        return !!(control && control.invalid && (control.touched || (form && form.submitted)));
    }
}
SbbErrorStateMatcher.ɵprov = i0.ɵɵdefineInjectable({ factory: function SbbErrorStateMatcher_Factory() { return new SbbErrorStateMatcher(); }, token: SbbErrorStateMatcher, providedIn: "root" });
SbbErrorStateMatcher.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** Error state matcher that matches when a control is invalid and dirty. */
class SbbShowOnDirtyErrorStateMatcher {
    isErrorState(control, form) {
        return !!(control && control.invalid && (control.dirty || (form && form.submitted)));
    }
}
SbbShowOnDirtyErrorStateMatcher.decorators = [
    { type: Injectable }
];

/**
 * Generated bundle index. Do not edit.
 */

export { SbbErrorStateMatcher, SbbShowOnDirtyErrorStateMatcher };
//# sourceMappingURL=error.js.map
