import { Injectable, NgModule } from '@angular/core';
import { SbbIconRegistry } from '@sbb-esta/angular-core/icon';
import { of } from 'rxjs';

// tslint:enable:no-any
/**
 * A null icon registry that must be imported to allow disabling of custom
 * icons.
 */
class FakeSbbIconRegistry {
    addSvgIcon() {
        return this;
    }
    addSvgIconLiteral() {
        return this;
    }
    addSvgIconInNamespace() {
        return this;
    }
    addSvgIconLiteralInNamespace() {
        return this;
    }
    addSvgIconSet() {
        return this;
    }
    addSvgIconSetLiteral() {
        return this;
    }
    addSvgIconSetInNamespace() {
        return this;
    }
    addSvgIconSetLiteralInNamespace() {
        return this;
    }
    registerFontClassAlias() {
        return this;
    }
    classNameForFontAlias(alias) {
        return alias;
    }
    getDefaultFontSetClass() {
        return 'sbb-icons';
    }
    getSvgIconFromUrl() {
        return of(this._generateEmptySvg());
    }
    getNamedSvgIcon() {
        return of(this._generateEmptySvg());
    }
    setDefaultFontSetClass() {
        return this;
    }
    hasNamespaceSvgIcon() {
        return true;
    }
    addSvgIconResolver() {
        return this;
    }
    ngOnDestroy() { }
    _generateEmptySvg() {
        const emptySvg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
        emptySvg.classList.add('fake-testing-svg');
        // Emulate real icon characteristics from `SbbIconRegistry` so size remains consistent in tests.
        emptySvg.setAttribute('fit', '');
        emptySvg.setAttribute('preserveAspectRatio', 'xMidYMid meet');
        emptySvg.setAttribute('focusable', 'false');
        return emptySvg;
    }
}
FakeSbbIconRegistry.decorators = [
    { type: Injectable }
];
/** Import this module in tests to install the null icon registry. */
class SbbIconTestingModule {
}
SbbIconTestingModule.decorators = [
    { type: NgModule, args: [{
                providers: [{ provide: SbbIconRegistry, useClass: FakeSbbIconRegistry }],
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { FakeSbbIconRegistry, SbbIconTestingModule };
//# sourceMappingURL=testing.js.map
