import { OnDestroy } from '@angular/core';
import { SbbIconRegistry } from '@sbb-esta/angular-core/icon';
import { Observable } from 'rxjs';
declare type PublicApi<T> = {
    [K in keyof T]: T[K] extends (...x: any[]) => T ? (...x: any[]) => PublicApi<T> : T[K];
};
/**
 * A null icon registry that must be imported to allow disabling of custom
 * icons.
 */
export declare class FakeSbbIconRegistry implements PublicApi<SbbIconRegistry>, OnDestroy {
    addSvgIcon(): this;
    addSvgIconLiteral(): this;
    addSvgIconInNamespace(): this;
    addSvgIconLiteralInNamespace(): this;
    addSvgIconSet(): this;
    addSvgIconSetLiteral(): this;
    addSvgIconSetInNamespace(): this;
    addSvgIconSetLiteralInNamespace(): this;
    registerFontClassAlias(): this;
    classNameForFontAlias(alias: string): string;
    getDefaultFontSetClass(): string;
    getSvgIconFromUrl(): Observable<SVGElement>;
    getNamedSvgIcon(): Observable<SVGElement>;
    setDefaultFontSetClass(): this;
    hasNamespaceSvgIcon(): boolean;
    addSvgIconResolver(): this;
    ngOnDestroy(): void;
    private _generateEmptySvg;
}
/** Import this module in tests to install the null icon registry. */
export declare class SbbIconTestingModule {
}
export {};
