/// <amd-module name="@sbb-esta/angular-core/schematics/ng-update/migrations/form-field-migration" />
import { Migration, ResolvedResource } from '@angular/cdk/schematics';
import * as ts from 'typescript';
/**
 * Migration for the sbb-form-field:
 * - updates imports from field to form-field.
 *   (e.g. @sbb-esta/angular-public/field => @sbb-esta/angular-public/form-field)
 * - renames sbb-field to sbb-form-field
 * - replaces mode with css classes
 * - removes for on sbb-label
 */
export declare class FormFieldMigration extends Migration<null> {
    enabled: boolean;
    readonly modeReplacements: {
        short: string;
        medium: string;
        long: string;
    };
    readonly modeVariants: string[];
    readonly compatibleFormControls: string[];
    readonly missingFormControl: string[];
    migrateFormFieldMode: boolean;
    migrateSbbInput: boolean;
    migrateSbbField: boolean;
    migrateLabelFor: boolean;
    visitNode(declaration: ts.Node): void;
    /** Method that will be called for each Angular template in the program. */
    visitTemplate(template: ResolvedResource): void;
    postAnalysis(): void;
    private _isInFormField;
    private _isFormField;
    private _hasCompatibleFormControl;
    private _hasInputDirective;
    private _hasModeInput;
    private _isSbbLabelWithFor;
    private _replaceMode;
    private _replaceAttributeMode;
    /**
     * Remove the mode, including preceding space. (e.g. ` mode="long"` => ``)
     */
    private _removeMode;
    private _insertModeClass;
}
