/// <amd-module name="@sbb-esta/angular-core/schematics/ng-update/migrations/prefix-migration" />
import { DevkitContext, Migration, ResolvedResource } from '@angular/cdk/schematics';
import * as ts from 'typescript';
export declare class PrefixMigration extends Migration<any, DevkitContext> {
    enabled: boolean;
    private _replacements;
    private _identifiers;
    /** Method can be used to perform global analysis of the program. */
    init(): void;
    /**
     * Method that will be called for each node in a given source file. Unlike tslint, this
     * function will only retrieve TypeScript nodes that need to be casted manually. This
     * allows us to only walk the program source files once per program and not per
     * migration rule (significant performance boost).
     */
    visitNode(node: ts.Node): void;
    private _visitClassOrInterfaceOrTypeAliasDeclaration;
    private _visitFunctionOrVariableDeclaration;
    private _hasExportModifier;
    /** Method that will be called for each Angular template in the program. */
    visitTemplate(_template: ResolvedResource): void;
    /** Method that will be called for each stylesheet in the program. */
    visitStylesheet(_stylesheet: ResolvedResource): void;
    /**
     * Method that will be called once all nodes, templates and stylesheets
     * have been visited.
     */
    postAnalysis(): void;
    private _replace;
    private _findPublicApiFile;
}
