export declare class FakeMediaQueryList {
    matches: boolean;
    media: string;
    /** The callback for change events. */
    private _listeners;
    constructor(matches: boolean, media: string);
    /** Toggles the matches state and "emits" a change event. */
    setMatches(matches: boolean): void;
    /** Registers a callback method for change events. */
    addListener(callback: (mql: MediaQueryListEvent) => void): void;
    /** Removes a callback method from the change events. */
    removeListener(callback: (mql: MediaQueryListEvent) => void): void;
}
export declare class FakeMediaMatcher {
    defaultMatches: boolean;
    /** A map of match media queries. */
    private _queries;
    /** The number of distinct queries created in the media matcher during a test. */
    get queryCount(): number;
    /** Fakes the match media response to be controlled in tests. */
    matchMedia(query: string): FakeMediaQueryList;
    /** Clears all queries from the map of queries. */
    clear(): void;
    /** Toggles the matching state of the provided query. */
    setMatchesQuery(query: string, matches: boolean): void;
}
